import _Dropdown from "@alifd/next/es/dropdown";
import _Menu from "@alifd/next/es/menu";
import _Button from "@alifd/next/es/button";
import _Icon from "@alifd/next/es/icon";
import _extends from "@babel/runtime/helpers/extends";
import _Balloon from "@alifd/next/es/balloon";
import _Tree from "@alifd/next/es/tree";
import React, { useState, useEffect } from 'react';
import './index.scss';
var TreeNode = _Tree.Node;
var Tooltip = _Balloon.Tooltip;
export default function SixueTree(props) {
  var others = _extends({}, props);

  var _useState = useState([]),
      now = _useState[0],
      setNow = _useState[1];

  var _useState2 = useState([]),
      treeSelected = _useState2[0],
      setTreeSelected = _useState2[1];

  var _useState3 = useState([]),
      expandedKeys = _useState3[0],
      setExpandedKeys = _useState3[1];

  var _useState4 = useState(true),
      auto = _useState4[0],
      setAuto = _useState4[1];

  useEffect(function () {
    var tree = document.getElementById('sixueTree');
    tree.addEventListener('scroll', scrollMeun);
    return function () {
      tree.addEventListener('scroll', scrollMeun);
    };
  }, []);
  useEffect(function () {
    setTreeSelected(others.selected);
    setExpandedKeys(others.expand);
    setAuto(true);
  }, [others.expand, others.selected]);

  var scrollMeun = function scrollMeun() {
    if (document.getElementById('treeFunc')) {
      // @ts-ignore
      document.getElementsByClassName('next-overlay-wrapper')[0].style = 'display: none';
    }
  };

  var getItemByPos = function getItemByPos(pos) {
    return pos.split('-').slice(1).reduce(function (ret, num) {
      return ret.children[num];
    }, {
      children: others.dataSource
    });
  };

  var loop = function loop(data, num) {
    var dataLength = data.length;
    return data.map(function (item, index) {
      if (item.enabled) {
        return loopAndLabelText(item, index, dataLength, num);
      } else {
        if (others.disableShow) {
          return loopAndLabelText(item, index, dataLength, num);
        }

        return '';
      }
    });
  };

  var loopAndLabelText = function loopAndLabelText(item, index, dataLength, num) {
    if (item.children) {
      return /*#__PURE__*/React.createElement(TreeNode, {
        key: item.key,
        label: labelText(item, index, dataLength, num)
      }, loop(item.children, num + 1));
    }

    return /*#__PURE__*/React.createElement(TreeNode, {
      key: item.key,
      label: labelText(item, index, dataLength, num),
      disabled: !!item.disabled
    });
  }; // eslint-disable-next-line max-len


  var labelText = function labelText(data, index, dataLength, num) {
    return /*#__PURE__*/React.createElement("div", {
      className: "treeName",
      key: data.key
    }, data.group && /*#__PURE__*/React.createElement(_Icon, {
      className: "treeFile",
      type: others.groupingIcon
    }), /*#__PURE__*/React.createElement("p", null, data.label.length > 8 ? /*#__PURE__*/React.createElement(Tooltip, {
      align: "t",
      trigger: /*#__PURE__*/React.createElement(_Button, {
        className: "treeName1",
        text: true
      }, data.label)
    }, data.label) : /*#__PURE__*/React.createElement(_Button, {
      className: "treeName1",
      text: true
    }, data.label), !data.enabled && /*#__PURE__*/React.createElement("i", {
      className: "stop"
    }, "[\u5DF2\u505C\u7528]"), /*#__PURE__*/React.createElement(_Dropdown, {
      trigger: /*#__PURE__*/React.createElement(_Button, {
        text: true,
        className: "treeMore"
      }, /*#__PURE__*/React.createElement(_Icon, {
        type: "ellipsis"
      })),
      triggerType: "click"
    }, /*#__PURE__*/React.createElement(_Menu, {
      className: "treeFunc",
      id: "treeFunc"
    }, /*#__PURE__*/React.createElement(_Menu.Item, {
      onClick: function onClick() {
        others.rename();
      }
    }, "\u91CD\u547D\u540D"), data.group && num < others.groupingMaxNum - 1 && /*#__PURE__*/React.createElement(_Menu.Item, {
      onClick: function onClick() {
        var pos = now.props.pos;
        var item = getItemByPos(pos);

        if (!(item === null || item === void 0 ? void 0 : item.children)) {
          item.children = [];
        }

        others.addChild();
      }
    }, "\u6DFB\u52A0\u5B50\u5206\u7EC4"), index !== 0 && /*#__PURE__*/React.createElement(_Menu.Item, {
      onClick: function onClick() {
        others.move('up');
      }
    }, "\u4E0A\u79FB"), index !== dataLength - 1 && /*#__PURE__*/React.createElement(_Menu.Item, {
      onClick: function onClick() {
        others.move('down');
      }
    }, "\u4E0B\u79FB"), index !== 0 && /*#__PURE__*/React.createElement(_Menu.Item, {
      onClick: function onClick() {
        others.move('top');
      }
    }, "\u7F6E\u9876"), index !== dataLength - 1 && /*#__PURE__*/React.createElement(_Menu.Item, {
      onClick: function onClick() {
        others.move('bottom');
      }
    }, "\u7F6E\u5E95"), /*#__PURE__*/React.createElement(_Menu.Item, {
      onClick: function onClick() {
        if (data.group) {
          others.remove('delete');
        } else {
          var pos = now.props.pos;
          var item = getItemByPos(pos);
          others.enableDisable(item.enabled);
        }
      }
    }, data.group ? '删除' : data.enabled ? '停用' : '启用')))));
  };

  var onSelect = function onSelect(keys, info) {
    var pos = info.node.props.pos;
    var item = getItemByPos(pos);
    others.onChange(item);
    setNow(info.node);

    if (keys.length >= 1) {
      setTreeSelected(keys);
    }
  };

  var onExpand = function onExpand(keys) {
    setExpandedKeys(keys);
    setAuto(false);
  };

  return /*#__PURE__*/React.createElement("div", {
    id: "sixueTree",
    className: "sixueTree"
  }, /*#__PURE__*/React.createElement(_Tree, {
    isNodeBlock: true,
    onSelect: onSelect,
    selectedKeys: treeSelected,
    onExpand: onExpand,
    expandedKeys: expandedKeys,
    autoExpandParent: auto
  }, loop(others.dataSource, 0)));
}
SixueTree.defaultProps = {
  groupingIcon: 'wenjianjia',
  disableShow: true,
  groupingMaxNum: 10
};