"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = SixueTree;

var _dropdown = _interopRequireDefault(require("@alifd/next/lib/dropdown"));

var _menu = _interopRequireDefault(require("@alifd/next/lib/menu"));

var _button = _interopRequireDefault(require("@alifd/next/lib/button"));

var _icon = _interopRequireDefault(require("@alifd/next/lib/icon"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _balloon = _interopRequireDefault(require("@alifd/next/lib/balloon"));

var _tree = _interopRequireDefault(require("@alifd/next/lib/tree"));

var _react = _interopRequireWildcard(require("react"));

require("./index.scss");

var TreeNode = _tree["default"].Node;
var Tooltip = _balloon["default"].Tooltip;

function SixueTree(props) {
  var others = (0, _extends2["default"])({}, props);

  var _useState = (0, _react.useState)([]),
      now = _useState[0],
      setNow = _useState[1];

  var _useState2 = (0, _react.useState)([]),
      treeSelected = _useState2[0],
      setTreeSelected = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      expandedKeys = _useState3[0],
      setExpandedKeys = _useState3[1];

  var _useState4 = (0, _react.useState)(true),
      auto = _useState4[0],
      setAuto = _useState4[1];

  (0, _react.useEffect)(function () {
    var tree = document.getElementById('sixueTree');
    tree.addEventListener('scroll', scrollMeun);
    return function () {
      tree.addEventListener('scroll', scrollMeun);
    };
  }, []);
  (0, _react.useEffect)(function () {
    setTreeSelected(others.selected);
    setExpandedKeys(others.expand);
    setAuto(true);
  }, [others.expand, others.selected]);

  var scrollMeun = function scrollMeun() {
    if (document.getElementById('treeFunc')) {
      // @ts-ignore
      document.getElementsByClassName('next-overlay-wrapper')[0].style = 'display: none';
    }
  };

  var getItemByPos = function getItemByPos(pos) {
    return pos.split('-').slice(1).reduce(function (ret, num) {
      return ret.children[num];
    }, {
      children: others.dataSource
    });
  };

  var loop = function loop(data, num) {
    var dataLength = data.length;
    return data.map(function (item, index) {
      if (item.enabled) {
        return loopAndLabelText(item, index, dataLength, num);
      } else {
        if (others.disableShow) {
          return loopAndLabelText(item, index, dataLength, num);
        }

        return '';
      }
    });
  };

  var loopAndLabelText = function loopAndLabelText(item, index, dataLength, num) {
    if (item.children) {
      return /*#__PURE__*/_react["default"].createElement(TreeNode, {
        key: item.key,
        label: labelText(item, index, dataLength, num)
      }, loop(item.children, num + 1));
    }

    return /*#__PURE__*/_react["default"].createElement(TreeNode, {
      key: item.key,
      label: labelText(item, index, dataLength, num),
      disabled: !!item.disabled
    });
  }; // eslint-disable-next-line max-len


  var labelText = function labelText(data, index, dataLength, num) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "treeName",
      key: data.key
    }, data.group && /*#__PURE__*/_react["default"].createElement(_icon["default"], {
      className: "treeFile",
      type: others.groupingIcon
    }), /*#__PURE__*/_react["default"].createElement("p", null, data.label.length > 8 ? /*#__PURE__*/_react["default"].createElement(Tooltip, {
      align: "t",
      trigger: /*#__PURE__*/_react["default"].createElement(_button["default"], {
        className: "treeName1",
        text: true
      }, data.label)
    }, data.label) : /*#__PURE__*/_react["default"].createElement(_button["default"], {
      className: "treeName1",
      text: true
    }, data.label), !data.enabled && /*#__PURE__*/_react["default"].createElement("i", {
      className: "stop"
    }, "[\u5DF2\u505C\u7528]"), /*#__PURE__*/_react["default"].createElement(_dropdown["default"], {
      trigger: /*#__PURE__*/_react["default"].createElement(_button["default"], {
        text: true,
        className: "treeMore"
      }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        type: "ellipsis"
      })),
      triggerType: "click"
    }, /*#__PURE__*/_react["default"].createElement(_menu["default"], {
      className: "treeFunc",
      id: "treeFunc"
    }, /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        others.rename();
      }
    }, "\u91CD\u547D\u540D"), data.group && num < others.groupingMaxNum - 1 && /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        var pos = now.props.pos;
        var item = getItemByPos(pos);

        if (!(item === null || item === void 0 ? void 0 : item.children)) {
          item.children = [];
        }

        others.addChild();
      }
    }, "\u6DFB\u52A0\u5B50\u5206\u7EC4"), index !== 0 && /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        others.move('up');
      }
    }, "\u4E0A\u79FB"), index !== dataLength - 1 && /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        others.move('down');
      }
    }, "\u4E0B\u79FB"), index !== 0 && /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        others.move('top');
      }
    }, "\u7F6E\u9876"), index !== dataLength - 1 && /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        others.move('bottom');
      }
    }, "\u7F6E\u5E95"), /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        if (data.group) {
          others.remove('delete');
        } else {
          var pos = now.props.pos;
          var item = getItemByPos(pos);
          others.enableDisable(item.enabled);
        }
      }
    }, data.group ? '删除' : data.enabled ? '停用' : '启用')))));
  };

  var onSelect = function onSelect(keys, info) {
    var pos = info.node.props.pos;
    var item = getItemByPos(pos);
    others.onChange(item);
    setNow(info.node);

    if (keys.length >= 1) {
      setTreeSelected(keys);
    }
  };

  var onExpand = function onExpand(keys) {
    setExpandedKeys(keys);
    setAuto(false);
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    id: "sixueTree",
    className: "sixueTree"
  }, /*#__PURE__*/_react["default"].createElement(_tree["default"], {
    isNodeBlock: true,
    onSelect: onSelect,
    selectedKeys: treeSelected,
    onExpand: onExpand,
    expandedKeys: expandedKeys,
    autoExpandParent: auto
  }, loop(others.dataSource, 0)));
}

SixueTree.defaultProps = {
  groupingIcon: 'wenjianjia',
  disableShow: true,
  groupingMaxNum: 10
};